Skip to content

Row hiding

Hide individual rows to avoid rendering them as DOM elements. It helps you reduce screen clutter and improve the grid’s performance.

Overview

“Hiding a row” means that the hidden row doesn’t get rendered as a DOM element.

When you’re hiding a row:

  • The source data doesn’t get modified.
  • The HiddenRows plugin doesn’t participate in data transformation
    (the shape of the data returned by the getData*() methods stays intact).

Enable row hiding

To enable row hiding, use the hiddenRows option.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example1');
new Handsontable(container, {
licenseKey: 'non-commercial-and-evaluation',
data: [
['A1', 'B1', 'C1', 'D1', 'E1'],
['A2', 'B2', 'C2', 'D2', 'E2'],
['A3', 'B3', 'C3', 'D3', 'E3'],
['A4', 'B4', 'C4', 'D4', 'E4'],
['A5', 'B5', 'C5', 'D5', 'E5'],
['A6', 'B6', 'C6', 'D6', 'E6'],
['A7', 'B7', 'C7', 'D7', 'E7'],
['A8', 'B8', 'C8', 'D8', 'E8'],
['A9', 'B9', 'C9', 'D9', 'E9'],
['A10', 'B10', 'C10', 'D10', 'E10'],
['A11', 'B11', 'C11', 'D11', 'E11'],
['A12', 'B12', 'C12', 'D12', 'E12'],
],
height: 'auto',
colHeaders: true,
rowHeaders: true,
// enable the `HiddenRows` plugin
hiddenRows: {
rows: [3, 5, 9],
// show UI indicators to mark hidden rows
indicators: true,
},
autoWrapRow: true,
autoWrapCol: true,
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example1')!;
new Handsontable(container, {
licenseKey: 'non-commercial-and-evaluation',
data: [
['A1', 'B1', 'C1', 'D1', 'E1'],
['A2', 'B2', 'C2', 'D2', 'E2'],
['A3', 'B3', 'C3', 'D3', 'E3'],
['A4', 'B4', 'C4', 'D4', 'E4'],
['A5', 'B5', 'C5', 'D5', 'E5'],
['A6', 'B6', 'C6', 'D6', 'E6'],
['A7', 'B7', 'C7', 'D7', 'E7'],
['A8', 'B8', 'C8', 'D8', 'E8'],
['A9', 'B9', 'C9', 'D9', 'E9'],
['A10', 'B10', 'C10', 'D10', 'E10'],
['A11', 'B11', 'C11', 'D11', 'E11'],
['A12', 'B12', 'C12', 'D12', 'E12'],
],
height: 'auto',
colHeaders: true,
rowHeaders: true,
// enable the `HiddenRows` plugin
hiddenRows: {
rows: [3, 5, 9],
// show UI indicators to mark hidden rows
indicators: true,
},
autoWrapRow: true,
autoWrapCol: true,
});

Set up row hiding

To set up your row hiding configuration, follow the steps below.

  1. Specify rows hidden by default

    To both enable row hiding and specify rows hidden by default, set the hiddenRows configuration option to an object.

    In the object, add a rows property, and set it to an array of row indexes.

    Now, those rows are hidden by default:

    JavaScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example2');
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the `HiddenRows` plugin
    hiddenRows: {
    // specify rows hidden by default
    rows: [3, 5, 9],
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    TypeScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example2')!;
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the `HiddenRows` plugin
    hiddenRows: {
    // specify rows hidden by default
    rows: [3, 5, 9],
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
  2. Show UI indicators

    To easily see which rows are currently hidden, display UI indicators.

    To enable the UI indicators, in the hiddenRows object, set the indicators property to true:

    JavaScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example3');
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    hiddenRows: {
    rows: [3, 5, 9],
    // show UI indicators to mark hidden rows
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    TypeScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example3')!;
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    hiddenRows: {
    rows: [3, 5, 9],
    // show UI indicators to mark hidden rows
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
  3. Set up context menu items

    To easily hide and unhide rows, add row hiding items to Handsontable’s context menu.

    Enable both the ContextMenu plugin and the HiddenRows plugin. Now, the context menu automatically displays additional items for hiding and unhiding rows.

    JavaScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example4');
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the context menu
    contextMenu: true,
    // enable the `HiddenRows` plugin
    // automatically adds the context menu's row hiding items
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    TypeScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example4')!;
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the context menu
    contextMenu: true,
    // enable the `HiddenRows` plugin
    // automatically adds the context menu's row hiding items
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });

    You can also add the row hiding menu items individually, by adding the hidden_rows_show and hidden_rows_hide strings to the contextMenu parameter:

    JavaScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example5');
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // individually add row hiding context menu items
    contextMenu: ['hidden_rows_show', 'hidden_rows_hide'],
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    TypeScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example5')!;
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // individually add row hiding context menu items
    contextMenu: ['hidden_rows_show', 'hidden_rows_hide'],
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
  4. Set up copy and paste behavior

    By default, hidden rows are included in copying and pasting.

    To exclude hidden rows from copying and pasting, in the hiddenRows object, set the copyPasteEnabled property to false:

    JavaScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example6');
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    contextMenu: ['hidden_rows_show', 'hidden_rows_hide'],
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    // exclude hidden rows from copying and pasting
    copyPasteEnabled: false,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    TypeScript
    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    // Register all Handsontable's modules.
    registerAllModules();
    const container = document.querySelector('#example6')!;
    new Handsontable(container, {
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    contextMenu: ['hidden_rows_show', 'hidden_rows_hide'],
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    // exclude hidden rows from copying and pasting
    copyPasteEnabled: false,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });

Row hiding API methods

For the most popular row hiding tasks, use the API methods below.

To see your changes, re-render your Handsontable instance with the render() method.

Access the HiddenRows plugin instance

To access the HiddenRows plugin instance, use the getPlugin() method:

const plugin = hot.getPlugin('hiddenRows');

Hide a single row

To hide a single row, use the hideRow() method:

const plugin = hot.getPlugin('hiddenRows');
plugin.hideRow(4);

Hide multiple rows

To hide multiple rows:

  • Either pass row indexes as arguments to the hideRow() method
  • Or pass an array of row indexes to the hideRows() method
const plugin = hot.getPlugin('hiddenRows');
plugin.hideRow(0, 4, 6);
// or
plugin.hideRows([0, 4, 6]);

Unhide a single row

To unhide a single row, use the showRow() method:

const plugin = hot.getPlugin('hiddenRows');
plugin.showRow(4);

Unhide multiple rows

To unhide multiple rows:

  • Either pass row indexes as arguments to the showRow() method
  • Or pass an array of row indexes to the showRows() method
const plugin = hot.getPlugin('hiddenRows');
plugin.showRow(0, 4, 6);
// or
plugin.showRows([0, 4, 6]);

Configuration options

Hooks

Plugins

Skip to content

Row hiding

Hide individual rows to avoid rendering them as DOM elements. It helps you reduce screen clutter and improve the grid’s performance.

Overview

“Hiding a row” means that the hidden row doesn’t get rendered as a DOM element.

When you’re hiding a row:

  • The source data doesn’t get modified.
  • The HiddenRows plugin doesn’t participate in data transformation
    (the shape of the data returned by the getData*() methods stays intact).

Enable row hiding

To enable row hiding, use the hiddenRows option.

JavaScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={[
['A1', 'B1', 'C1', 'D1', 'E1'],
['A2', 'B2', 'C2', 'D2', 'E2'],
['A3', 'B3', 'C3', 'D3', 'E3'],
['A4', 'B4', 'C4', 'D4', 'E4'],
['A5', 'B5', 'C5', 'D5', 'E5'],
['A6', 'B6', 'C6', 'D6', 'E6'],
['A7', 'B7', 'C7', 'D7', 'E7'],
['A8', 'B8', 'C8', 'D8', 'E8'],
['A9', 'B9', 'C9', 'D9', 'E9'],
['A10', 'B10', 'C10', 'D10', 'E10'],
['A11', 'B11', 'C11', 'D11', 'E11'],
['A12', 'B12', 'C12', 'D12', 'E12'],
]}
height="auto"
colHeaders={true}
rowHeaders={true}
hiddenRows={{
rows: [3, 5, 9],
// show UI indicators to mark hidden rows
indicators: true,
}}
/>
);
};
export default ExampleComponent;
TypeScript
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
return (
<HotTable
autoWrapRow={true}
autoWrapCol={true}
licenseKey="non-commercial-and-evaluation"
data={[
['A1', 'B1', 'C1', 'D1', 'E1'],
['A2', 'B2', 'C2', 'D2', 'E2'],
['A3', 'B3', 'C3', 'D3', 'E3'],
['A4', 'B4', 'C4', 'D4', 'E4'],
['A5', 'B5', 'C5', 'D5', 'E5'],
['A6', 'B6', 'C6', 'D6', 'E6'],
['A7', 'B7', 'C7', 'D7', 'E7'],
['A8', 'B8', 'C8', 'D8', 'E8'],
['A9', 'B9', 'C9', 'D9', 'E9'],
['A10', 'B10', 'C10', 'D10', 'E10'],
['A11', 'B11', 'C11', 'D11', 'E11'],
['A12', 'B12', 'C12', 'D12', 'E12'],
]}
height="auto"
colHeaders={true}
rowHeaders={true}
hiddenRows={{
rows: [3, 5, 9],
// show UI indicators to mark hidden rows
indicators: true,
}}
/>
);
};
export default ExampleComponent;

Set up row hiding

To set up your row hiding configuration, follow the steps below.

  1. Specify rows hidden by default

    To both enable row hiding and specify rows hidden by default, set the hiddenRows configuration option to an object.

    In the object, add a rows property, and set it to an array of row indexes.

    Now, those rows are hidden by default:

    JavaScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    hiddenRows={{
    // specify rows hidden by default
    rows: [3, 5, 9],
    }}
    />
    );
    };
    export default ExampleComponent;
    TypeScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    hiddenRows={{
    // specify rows hidden by default
    rows: [3, 5, 9],
    }}
    />
    );
    };
    export default ExampleComponent;
  2. Show UI indicators

    To easily see which rows are currently hidden, display UI indicators.

    To enable the UI indicators, in the hiddenRows object, set the indicators property to true:

    JavaScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    hiddenRows={{
    rows: [3, 5, 9],
    // show UI indicators to mark hidden rows
    indicators: true,
    }}
    />
    );
    };
    export default ExampleComponent;
    TypeScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    hiddenRows={{
    rows: [3, 5, 9],
    // show UI indicators to mark hidden rows
    indicators: true,
    }}
    />
    );
    };
    export default ExampleComponent;
  3. Set up context menu items

    To easily hide and unhide rows, add row hiding items to Handsontable’s context menu.

    Enable both the ContextMenu plugin and the HiddenRows plugin. Now, the context menu automatically displays additional items for hiding and unhiding rows.

    JavaScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    contextMenu={true}
    hiddenRows={{
    rows: [3, 5, 9],
    indicators: true,
    }}
    />
    );
    };
    export default ExampleComponent;
    TypeScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    contextMenu={true}
    hiddenRows={{
    rows: [3, 5, 9],
    indicators: true,
    }}
    />
    );
    };
    export default ExampleComponent;

    You can also add the row hiding menu items individually, by adding the hidden_rows_show and hidden_rows_hide strings to the contextMenu parameter:

    JavaScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    contextMenu={['hidden_rows_show', 'hidden_rows_hide']}
    hiddenRows={{
    rows: [3, 5, 9],
    indicators: true,
    }}
    />
    );
    };
    export default ExampleComponent;
    TypeScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    contextMenu={['hidden_rows_show', 'hidden_rows_hide']}
    hiddenRows={{
    rows: [3, 5, 9],
    indicators: true,
    }}
    />
    );
    };
    export default ExampleComponent;
  4. Set up copy and paste behavior

    By default, hidden rows are included in copying and pasting.

    To exclude hidden rows from copying and pasting, in the hiddenRows object, set the copyPasteEnabled property to false:

    JavaScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    contextMenu={['hidden_rows_show', 'hidden_rows_hide']}
    hiddenRows={{
    rows: [3, 5, 9],
    indicators: true,
    // exclude hidden rows from copying and pasting
    copyPasteEnabled: false,
    }}
    />
    );
    };
    export default ExampleComponent;
    TypeScript
    import { HotTable } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    // register Handsontable's modules
    registerAllModules();
    const ExampleComponent = () => {
    return (
    <HotTable
    autoWrapRow={true}
    autoWrapCol={true}
    licenseKey="non-commercial-and-evaluation"
    data={[
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ]}
    height="auto"
    colHeaders={true}
    rowHeaders={true}
    contextMenu={['hidden_rows_show', 'hidden_rows_hide']}
    hiddenRows={{
    rows: [3, 5, 9],
    indicators: true,
    // exclude hidden rows from copying and pasting
    copyPasteEnabled: false,
    }}
    />
    );
    };
    export default ExampleComponent;

Row hiding API methods

For the most popular row hiding tasks, use the API methods below.

To see your changes, re-render your Handsontable instance with the render() method.

Access the HiddenRows plugin instance

To access the HiddenRows plugin instance, use the getPlugin() method:

const plugin = hot.getPlugin('hiddenRows');

Hide a single row

To hide a single row, use the hideRow() method:

const plugin = hot.getPlugin('hiddenRows');
plugin.hideRow(4);

Hide multiple rows

To hide multiple rows:

  • Either pass row indexes as arguments to the hideRow() method
  • Or pass an array of row indexes to the hideRows() method
const plugin = hot.getPlugin('hiddenRows');
plugin.hideRow(0, 4, 6);
// or
plugin.hideRows([0, 4, 6]);

Unhide a single row

To unhide a single row, use the showRow() method:

const plugin = hot.getPlugin('hiddenRows');
plugin.showRow(4);

Unhide multiple rows

To unhide multiple rows:

  • Either pass row indexes as arguments to the showRow() method
  • Or pass an array of row indexes to the showRows() method
const plugin = hot.getPlugin('hiddenRows');
plugin.showRow(0, 4, 6);
// or
plugin.showRows([0, 4, 6]);

Configuration options

Hooks

Plugins

Skip to content

Row hiding

Hide individual rows to avoid rendering them as DOM elements. It helps you reduce screen clutter and improve the grid’s performance.

Overview

“Hiding a row” means that the hidden row doesn’t get rendered as a DOM element.

When you’re hiding a row:

  • The source data doesn’t get modified.
  • The HiddenRows plugin doesn’t participate in data transformation
    (the shape of the data returned by the getData*() methods stays intact).

Enable row hiding

To enable row hiding, use the hiddenRows option.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({
licenseKey: 'non-commercial-and-evaluation',
data: [
['A1', 'B1', 'C1', 'D1', 'E1'],
['A2', 'B2', 'C2', 'D2', 'E2'],
['A3', 'B3', 'C3', 'D3', 'E3'],
['A4', 'B4', 'C4', 'D4', 'E4'],
['A5', 'B5', 'C5', 'D5', 'E5'],
['A6', 'B6', 'C6', 'D6', 'E6'],
['A7', 'B7', 'C7', 'D7', 'E7'],
['A8', 'B8', 'C8', 'D8', 'E8'],
['A9', 'B9', 'C9', 'D9', 'E9'],
['A10', 'B10', 'C10', 'D10', 'E10'],
['A11', 'B11', 'C11', 'D11', 'E11'],
['A12', 'B12', 'C12', 'D12', 'E12'],
],
height: 'auto',
colHeaders: true,
rowHeaders: true,
// enable the `HiddenRows` plugin
hiddenRows: {
rows: [3, 5, 9],
// show UI indicators to mark hidden rows
indicators: true,
},
autoWrapRow: true,
autoWrapCol: true,
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

Set up row hiding

To set up your row hiding configuration, follow the steps below.

  1. Specify rows hidden by default

    To both enable row hiding and specify rows hidden by default, set the hiddenRows configuration option to an object.

    In the object, add a rows property, and set it to an array of row indexes.

    Now, those rows are hidden by default:

    Vue
    <script setup lang="ts">
    import { ref } from 'vue';
    import { HotTable } from '@handsontable/vue3';
    import { registerAllModules } from 'handsontable/registry';
    import type { GridSettings } from 'handsontable/settings';
    registerAllModules();
    const hotSettings = ref<GridSettings>({
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the `HiddenRows` plugin
    hiddenRows: {
    // specify rows hidden by default
    rows: [3, 5, 9],
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    </script>
    <template>
    <div id="example2">
    <HotTable :settings="hotSettings" />
    </div>
    </template>
  2. Show UI indicators

    To easily see which rows are currently hidden, display UI indicators.

    To enable the UI indicators, in the hiddenRows object, set the indicators property to true:

    Vue
    <script setup lang="ts">
    import { ref } from 'vue';
    import { HotTable } from '@handsontable/vue3';
    import { registerAllModules } from 'handsontable/registry';
    import type { GridSettings } from 'handsontable/settings';
    registerAllModules();
    const hotSettings = ref<GridSettings>({
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    hiddenRows: {
    rows: [3, 5, 9],
    // show UI indicators to mark hidden rows
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    </script>
    <template>
    <div id="example3">
    <HotTable :settings="hotSettings" />
    </div>
    </template>
  3. Set up context menu items

    To easily hide and unhide rows, add row hiding items to Handsontable’s context menu.

    Enable both the ContextMenu plugin and the HiddenRows plugin. Now, the context menu automatically displays additional items for hiding and unhiding rows.

    Vue
    <script setup lang="ts">
    import { ref } from 'vue';
    import { HotTable } from '@handsontable/vue3';
    import { registerAllModules } from 'handsontable/registry';
    import type { GridSettings } from 'handsontable/settings';
    registerAllModules();
    const hotSettings = ref<GridSettings>({
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the context menu
    contextMenu: true,
    // enable the `HiddenRows` plugin
    // automatically adds the context menu's row hiding items
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    </script>
    <template>
    <div id="example4">
    <HotTable :settings="hotSettings" />
    </div>
    </template>

    You can also add the row hiding menu items individually, by adding the hidden_rows_show and hidden_rows_hide strings to the contextMenu parameter:

    Vue
    <script setup lang="ts">
    import { ref } from 'vue';
    import { HotTable } from '@handsontable/vue3';
    import { registerAllModules } from 'handsontable/registry';
    import type { GridSettings } from 'handsontable/settings';
    registerAllModules();
    const hotSettings = ref<GridSettings>({
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // individually add row hiding context menu items
    contextMenu: ['hidden_rows_show', 'hidden_rows_hide'],
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    </script>
    <template>
    <div id="example5">
    <HotTable :settings="hotSettings" />
    </div>
    </template>
  4. Set up copy and paste behavior

    By default, hidden rows are included in copying and pasting.

    To exclude hidden rows from copying and pasting, in the hiddenRows object, set the copyPasteEnabled property to false:

    Vue
    <script setup lang="ts">
    import { ref } from 'vue';
    import { HotTable } from '@handsontable/vue3';
    import { registerAllModules } from 'handsontable/registry';
    import type { GridSettings } from 'handsontable/settings';
    registerAllModules();
    const hotSettings = ref<GridSettings>({
    licenseKey: 'non-commercial-and-evaluation',
    data: [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
    ],
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    contextMenu: ['hidden_rows_show', 'hidden_rows_hide'],
    hiddenRows: {
    rows: [3, 5, 9],
    indicators: true,
    // exclude hidden rows from copying and pasting
    copyPasteEnabled: false,
    },
    autoWrapRow: true,
    autoWrapCol: true,
    });
    </script>
    <template>
    <div id="example6">
    <HotTable :settings="hotSettings" />
    </div>
    </template>

Row hiding API methods

For the most popular row hiding tasks, use the API methods below.

To see your changes, re-render your Handsontable instance with the render() method.

Access the HiddenRows plugin instance

To access the HiddenRows plugin instance, use the getPlugin() method:

const plugin = hot.getPlugin('hiddenRows');

Hide a single row

To hide a single row, use the hideRow() method:

const plugin = hot.getPlugin('hiddenRows');
plugin.hideRow(4);

Hide multiple rows

To hide multiple rows:

  • Either pass row indexes as arguments to the hideRow() method
  • Or pass an array of row indexes to the hideRows() method
const plugin = hot.getPlugin('hiddenRows');
plugin.hideRow(0, 4, 6);
// or
plugin.hideRows([0, 4, 6]);

Unhide a single row

To unhide a single row, use the showRow() method:

const plugin = hot.getPlugin('hiddenRows');
plugin.showRow(4);

Unhide multiple rows

To unhide multiple rows:

  • Either pass row indexes as arguments to the showRow() method
  • Or pass an array of row indexes to the showRows() method
const plugin = hot.getPlugin('hiddenRows');
plugin.showRow(0, 4, 6);
// or
plugin.showRows([0, 4, 6]);

Configuration options

Hooks

Plugins

Angular Data GridRow hiding

Hide individual rows to avoid rendering them as DOM elements. It helps you reduce screen clutter and improve the grid's performance.

Overview

"Hiding a row" means that the hidden row doesn't get rendered as a DOM element.

When you're hiding a row:

  • The source data doesn't get modified.
  • The HiddenRows plugin doesn't participate in data transformation
    (the shape of the data returned by the getData*() methods stays intact).

Enable row hiding

To enable row hiding, use the hiddenRows option.

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

@Component({
  selector: 'app-example1',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  readonly hotData = [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
  ];

  readonly hotSettings: GridSettings = {
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the `HiddenRows` plugin
    hiddenRows: {
      rows: [3, 5, 9],
      // show UI indicators to mark hidden rows
      indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Set up row hiding

To set up your row hiding configuration, follow the steps below.

Step 1: Specify rows hidden by default

To both enable row hiding and specify rows hidden by default, set the hiddenRows configuration option to an object.

In the object, add a rows property, and set it to an array of row indexes.

Now, those rows are hidden by default:

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

@Component({
  selector: 'app-example2',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  readonly hotData = [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
  ];

  readonly hotSettings: GridSettings = {
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the `HiddenRows` plugin
    hiddenRows: {
      // specify rows hidden by default
      rows: [3, 5, 9],
    },
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Step 2: Show UI indicators

To easily see which rows are currently hidden, display UI indicators.

To enable the UI indicators, in the hiddenRows object, set the indicators property to true:

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

@Component({
  selector: 'app-example3',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  readonly hotData = [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
  ];

  readonly hotSettings: GridSettings = {
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    hiddenRows: {
      rows: [3, 5, 9],
      // show UI indicators to mark hidden rows
      indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Step 3: Set up context menu items

To easily hide and unhide rows, add row hiding items to Handsontable's context menu.

Enable both the ContextMenu plugin and the HiddenRows plugin. Now, the context menu automatically displays additional items for hiding and unhiding rows.

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

@Component({
  selector: 'app-example4',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  readonly hotData = [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
  ];

  readonly hotSettings: GridSettings = {
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // enable the context menu
    contextMenu: true,
    // enable the `HiddenRows` plugin
    // automatically adds the context menu's row hiding items
    hiddenRows: {
      rows: [3, 5, 9],
      indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

You can also add the row hiding menu items individually, by adding the hidden_rows_show and hidden_rows_hide strings to the contextMenu parameter:

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

@Component({
  selector: 'app-example5',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  readonly hotData = [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
  ];

  readonly hotSettings: GridSettings = {
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    // individually add row hiding context menu items
    contextMenu: ['hidden_rows_show', 'hidden_rows_hide'],
    hiddenRows: {
      rows: [3, 5, 9],
      indicators: true,
    },
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Step 4: Set up copy and paste behavior

By default, hidden rows are included in copying and pasting.

To exclude hidden rows from copying and pasting, in the hiddenRows object, set the copyPasteEnabled property to false:

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

@Component({
  selector: 'app-example6',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  readonly hotData = [
    ['A1', 'B1', 'C1', 'D1', 'E1'],
    ['A2', 'B2', 'C2', 'D2', 'E2'],
    ['A3', 'B3', 'C3', 'D3', 'E3'],
    ['A4', 'B4', 'C4', 'D4', 'E4'],
    ['A5', 'B5', 'C5', 'D5', 'E5'],
    ['A6', 'B6', 'C6', 'D6', 'E6'],
    ['A7', 'B7', 'C7', 'D7', 'E7'],
    ['A8', 'B8', 'C8', 'D8', 'E8'],
    ['A9', 'B9', 'C9', 'D9', 'E9'],
    ['A10', 'B10', 'C10', 'D10', 'E10'],
    ['A11', 'B11', 'C11', 'D11', 'E11'],
    ['A12', 'B12', 'C12', 'D12', 'E12'],
  ];

  readonly hotSettings: GridSettings = {
    height: 'auto',
    colHeaders: true,
    rowHeaders: true,
    contextMenu: ['hidden_rows_show', 'hidden_rows_hide'],
    hiddenRows: {
      rows: [3, 5, 9],
      indicators: true,
      // exclude hidden rows from copying and pasting
      copyPasteEnabled: false,
    },
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Row hiding API methods

For the most popular row hiding tasks, use the API methods below.

To see your changes, re-render your Handsontable instance with the render() method.

To obtain the Handsontable instance from the Angular wrapper component, you can use Angular's @ViewChild decorator to reference the HotTableComponent and then access its hotInstance property.

@ViewChild(HotTableComponent, {static: false})
hotTable!: HotTableComponent;

ngAfterViewInit() {
  // The Handsontable instance is available through the hotInstance property
  const hot = this.hotTable.hotInstance;
  // You can now use the "hot" instance to call Handsontable's API methods
  // ...
}

Access the HiddenRows plugin instance

To access the HiddenRows plugin instance, use the getPlugin() method:

const plugin = hot.getPlugin('hiddenRows');

Hide a single row

To hide a single row, use the hideRow() method:

const plugin = hot.getPlugin('hiddenRows');

plugin.hideRow(4);

Hide multiple rows

To hide multiple rows:

  • Either pass row indexes as arguments to the hideRow() method
  • Or pass an array of row indexes to the hideRows() method
const plugin = hot.getPlugin('hiddenRows');

plugin.hideRow(0, 4, 6);
// or
plugin.hideRows([0, 4, 6]);

Unhide a single row

To unhide a single row, use the showRow() method:

const plugin = hot.getPlugin('hiddenRows');

plugin.showRow(4);

Unhide multiple rows

To unhide multiple rows:

  • Either pass row indexes as arguments to the showRow() method
  • Or pass an array of row indexes to the showRows() method
const plugin = hot.getPlugin('hiddenRows');

plugin.showRow(0, 4, 6);
// or
plugin.showRows([0, 4, 6]);